function _extends() {_extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};return _extends.apply(this, arguments);}const { createStore, applyMiddleware, bindActionCreators, combineReducers } = Redux;
const { Provider, connect } = ReactRedux;

const API_BASE_URL = "https://content.googleapis.com/youtube/v3/";
const API_KEY = "AIzaSyDFDYDtEDbJWXF3_5g5cwT-KYB-HtuCEd8";

const SEARCH_VIDEOS = 'SEARCH_VIDEOS';
const FETCH_CAT_VIDEOS = 'FETCH_CAT_VIDEOS';
const FETCH_POPULAR_CAT_VIDEOS = 'FETCH_POPULAR_CAT_VIDEOS';
const FETCH_FEATURED_VIDEO = 'FETCH_FEATURED_VIDEO';
const REMOVE_VIDEO_FROM_LIST = 'REMOVE_VIDEO_FROM_LIST';
const ADD_VIDEO_TO_LIST = 'ADD_VIDEO_TO_LIST';
const ADD_TO_WATCHED = 'ADD_TO_WATCHED';


/**************************************************/
// Middleware
/**************************************************/
const async = ({ dispatch }) => next => action => {

  if (!action.payload || !action.payload.then) {
    return next(action);
  }

  action.payload.then(function (response) {
    return response.json();
  }).then(function (data) {
    const newAction = { ...action, payload: data };
    dispatch(newAction);
  });
};

/**************************************************/
// Class Components
/**************************************************/
class App extends React.Component {

  constructor(props) {
    super(props);
    this.onClickAddToList = this.onClickAddToList.bind(this);
    this.onSearchTermChanges = this.onSearchTermChanges.bind(this);
    this.goTo = this.goTo.bind(this);

    this.state = {
      path: '/',
      params: null };


    this.onSearchTermChanges = _.debounce(this.onSearchTermChanges, 300);
  }

  componentDidMount() {
    window.addEventListener('scroll', this.handleScroll);
  }

  componentWillUnmount() {
    window.removeEventListener('scroll', this.handleScroll);
  }

  handleScroll(e) {
    let scrollTop = window.scrollY;
    if (scrollTop > 0) {
      document.body.classList.add('scroll');
    } else {
      document.body.classList.remove('scroll');
    }
  }

  onSearchTermChanges(term) {
    if (!_.isEmpty(term)) {
      this.props.searchVideos(term);
      this.goTo('/search', { isAnimated: false });
    } else
    {
      this.goTo('/', { isAnimated: false });
    }
  }

  onClickAddToList(video) {
    const videoId = video.id.videoId || video.id;

    if (_.isEmpty(this.props.listedVideos[videoId])) {
      this.props.addVideoToList(video);
    } else {
      this.props.removeVideoFromList(videoId);
    }
  }

  goTo(path, params) {
    let app = this;
    const { isAnimated = true } = params;

    if (this.state.path !== path)
    {
      document.body.classList.remove("zoom");

      if (isAnimated) {
        document.body.classList.add("zoom");
        setTimeout(function () {
          window.scrollTo(0, 0);
          document.body.classList.remove("zoom");
          app.setState({ path, params });
        }, 800);
      } else

      {
        app.setState({ path, params });
      }
    }
  }

  render() {
    if (_.isEmpty(this.props.videos) || _.isEmpty(this.props.featuredVideo)) {
      return /*#__PURE__*/React.createElement("div", null, "Loading ...");
    }

    const HeaderHandler = this.state.path !== '/watch' ? HeaderBrowse : HeaderWatch;
    const ContentHandler = PATHS[this.state.path];

    return /*#__PURE__*/(
      React.createElement("div", null, /*#__PURE__*/
      React.createElement(HeaderHandler, {
        goTo: this.goTo,
        onSearchTermChanges: this.onSearchTermChanges }), /*#__PURE__*/
      React.createElement(ContentHandler, _extends({},
      this.props,
      this.state, {
        goTo: this.goTo,
        onClickAddToList: this.onClickAddToList })), /*#__PURE__*/
      React.createElement(Footer, null)));


  }}


class Watch extends React.Component {

  componentDidMount() {
    this.props.addToWatchedVideos(this.props.params.id);
  }

  render() {
    const videoId = this.props.params.id;
    return /*#__PURE__*/(
      React.createElement("div", { className: "content content-watch" }, /*#__PURE__*/
      React.createElement("div", { className: "embed-responsive embed-responsive-16by9" }, /*#__PURE__*/
      React.createElement(Iframe, {
        className: "embed-responsive-item",
        videoId: videoId }))));



  }}



class Browse extends React.Component {
  render() {
    return /*#__PURE__*/(
      React.createElement("div", { className: "page page-browse" }, /*#__PURE__*/
      React.createElement(VideoStage, {
        goTo: this.props.goTo,
        video: this.props.featuredVideo }), /*#__PURE__*/

      React.createElement(VideoSlider, {
        listedVideos: this.props.watchedVideos,
        goTo: this.props.goTo,
        onClickAddToList: this.props.onClickAddToList,
        headline: 'Continue Watching for Mr. Sniffles',
        videos: this.props.watchedVideos,
        videosListed: this.props.listedVideos }), /*#__PURE__*/

      React.createElement(VideoSlider, {
        listedVideos: this.props.listedVideos,
        goTo: this.props.goTo,
        onClickAddToList: this.props.onClickAddToList,
        headline: 'My List',
        videos: this.props.listedVideos,
        videosListed: this.props.listedVideos }), /*#__PURE__*/

      React.createElement(VideoSlider, {
        listedVideos: this.props.listedVideos,
        goTo: this.props.goTo,
        onClickAddToList: this.props.onClickAddToList,
        headline: 'Popular on Catflix',
        videos: this.props.popularVideos,
        videosListed: this.props.listedVideos })));


  }}


class Search extends React.Component {

  constructor(props) {
    super(props);
    this.state = { tilesInRow: 4 };
  }

  renderSliders() {
    const videos = this.props.foundVideos;
    let counter = 1;
    let tmpVideos = {};
    let sliders = [];
    let windowWidth = window.innerWidth;

    for (let index in videos) {
      let video = videos[index];

      tmpVideos[video.id.videoId] = video;

      if (counter === 10) {
        counter = 0;

        sliders.push( /*#__PURE__*/
        React.createElement(VideoSlider, {
          key: video.id.videoId,
          listedVideos: this.props.listedVideos,
          goTo: this.props.goTo,
          onClickAddToList: this.props.onClickAddToList,
          videos: tmpVideos }));

        tmpVideos = {};
      }
      counter++;
    }
    return sliders;
  }

  render() {
    if (_.isEmpty(this.props.foundVideos)) {
      return /*#__PURE__*/React.createElement("div", null, "Loading ...");
    }

    return /*#__PURE__*/(
      React.createElement("div", { className: "page-search" },
      this.renderSliders()));


  }}



class SearchBar extends React.Component {

  constructor(props) {
    super(props);

    this.onIconClick = this.onIconClick.bind(this);
    this.onSearchbarBlur = this.onSearchbarBlur.bind(this);
    this.state = { term: '', isOpen: false };
  }

  onInputChange(term) {
    this.setState({ term, isOpen: _.isEmpty(term) ? false : true });
    this.props.onSearchTermChanges(term);
  }

  onIconClick(event) {
    this.setState({ isOpen: true });
    document.getElementById('search').focus();
  }

  onSearchbarBlur(event) {
    this.setState({ isOpen: false });
  }

  render() {
    return /*#__PURE__*/(
      React.createElement("div", {
        onClick: this.onIconClick,
        className: 'searchbar' + (this.state.isOpen ? ' open' : '') }, /*#__PURE__*/
      React.createElement("div", { className: "searchbar-outer" }, /*#__PURE__*/
      React.createElement("div", { className: "searchbar-inner" }, /*#__PURE__*/
      React.createElement("i", { className: "icon-search" }), /*#__PURE__*/
      React.createElement("input", {
        id: "search",
        name: "search",
        type: "text",
        placeholder: "Cats, cats and cats",
        value: this.state.term,
        onChange: event => this.onInputChange(event.target.value),
        autoComplete: "off",
        onBlur: this.onSearchbarBlur })))));




  }}



/**************************************************/
// Functional Components
/**************************************************/
const HeaderWatch = props => {
  return /*#__PURE__*/(
    React.createElement("div", { id: "header", className: "header header-watch" }, /*#__PURE__*/
    React.createElement("button", { className: "btn-back",
      onClick: () => {props.goTo('/', {});} })));


};

const HeaderBrowse = props => {
  return /*#__PURE__*/(
    React.createElement("header", { id: "header", className: "header header-main" }, /*#__PURE__*/
    React.createElement("div", { className: "container" }, /*#__PURE__*/
    React.createElement("div", { className: "header-left" }, /*#__PURE__*/
    React.createElement("div", {
      onClick: () => {props.goTo('/', {});},
      className: "logo logo-catflix" }), /*#__PURE__*/

    React.createElement("nav", { className: "nav nav-primary" }, /*#__PURE__*/
    React.createElement("ul", null, /*#__PURE__*/
    React.createElement("li", {
      onClick: () => {props.goTo('/', {});},
      className: "nav-item" }, "Home"), /*#__PURE__*/
    React.createElement("li", { className: "nav-item" }, "Cat Shows"), /*#__PURE__*/
    React.createElement("li", { className: "nav-item" }, "Movies"), /*#__PURE__*/
    React.createElement("li", { className: "nav-item" }, "Originals"), /*#__PURE__*/
    React.createElement("li", { className: "nav-item" }, "Recently Added"), /*#__PURE__*/
    React.createElement("li", { className: "nav-item" }, "My List")))), /*#__PURE__*/




    React.createElement("div", { className: "header-right" }, /*#__PURE__*/
    React.createElement(SearchBar, {
      onSearchTermChanges: props.onSearchTermChanges }), /*#__PURE__*/
    React.createElement("span", { className: "txt-nav-primary txt-uppercase" }, "Kids"), /*#__PURE__*/
    React.createElement("i", { className: "icon-notification" }), /*#__PURE__*/
    React.createElement("div", { className: "box box-user" }, /*#__PURE__*/
    React.createElement("img", { width: "32", height: "32", src: "https://pic.glowing.com/forum/05d1676cea75ffd2fa43438b49d12a2a.jpg", alt: "" }))))));





};

const Footer = () => {
  return /*#__PURE__*/(
    React.createElement("div", { id: "footer" }));

};

const VideoStage = props => {
  const videoId = props.video.id.videoId || props.video.id;

  return /*#__PURE__*/(
    React.createElement("div", { className: "stage" }, /*#__PURE__*/
    React.createElement("div", { className: "stage-inner" }, /*#__PURE__*/
    React.createElement("div", { className: "stage-overlay" }), /*#__PURE__*/
    React.createElement("div", { className: "embed-responsive embed-responsive-16by7" }, /*#__PURE__*/
    React.createElement(Iframe, { className: "embed-responsive-item",
      videoId: videoId })), /*#__PURE__*/

    React.createElement("div", { className: "stage-meta" }, /*#__PURE__*/
    React.createElement("h1", { className: "txt-big" }, "21"), /*#__PURE__*/
    React.createElement("h1", { className: "txt-med" }, "CAT shows and movies ", /*#__PURE__*/React.createElement("br", null), " added in the last 2 days."), /*#__PURE__*/
    React.createElement("button", { onClick: () => {props.goTo('/watch', { id: props.video.id });}, className: "btn" }, "Play")))));




};


const VideoSlider = props => {
  if (_.isEmpty(props.videos)) {
    return false;
  }

  return /*#__PURE__*/(
    React.createElement("div", { className: "contain" },
    renderSliderControls(_.size(props.videos)), /*#__PURE__*/
    React.createElement("div", { className: "row" }, /*#__PURE__*/
    React.createElement("div", { className: "row-scroll" }, /*#__PURE__*/
    React.createElement("h2", null,
    !_.isEmpty(props.headline) ? props.headline : ''), /*#__PURE__*/

    React.createElement("div", { className: "row-inner" },
    _.map(props.videos, function (video) {
      const videoId = video.id.videoId || video.id;
      return /*#__PURE__*/(
        React.createElement(VideoSliderItem, {
          key: videoId,
          listedVideos: props.listedVideos,
          video: video,
          goTo: props.goTo,
          onClickAddToList: props.onClickAddToList,
          videosListed: props.videosListed }));


    }))))));





};


const VideoSliderItem = props => {
  const videoId = props.video.id.videoId || props.video.id;
  const isListed = !_.isEmpty(props.listedVideos[videoId]) ? true : false;

  return /*#__PURE__*/(
    React.createElement("div", { key: videoId, className: "tile" }, /*#__PURE__*/
    React.createElement("div", { className: "tile-media" }, /*#__PURE__*/
    React.createElement("img", { className: "tile-img", src: props.video.snippet.thumbnails.high.url, alt: "" })), /*#__PURE__*/

    React.createElement("div", { className: "tile-details",
      onClick: () => {props.goTo('/watch', { id: videoId });} }, /*#__PURE__*/
    React.createElement("div", { className: "tile-title" },
    props.video.snippet.title)),


    renderAddToListButton(isListed, () => props.onClickAddToList(props.video))));


};


const Iframe = props => {
  const autoplay = props.autoplay || 0;
  return /*#__PURE__*/(
    React.createElement("iframe", { className: props.className, type: "text/html", width: "640", height: "360", src: "https://www.youtube.com/embed/" + props.videoId + "?&rel=0&showinfo=0&loop=1&autoplay=" + autoplay, frameBorder: "0", allowFullScreen: true }));

};


/**************************************************/
// Helper Functions
/**************************************************/
function findAncestor(el, cls) {
  while ((el = el.parentElement) && !el.classList.contains(cls));
  return el;
}

function animateScrollTo(element, to, duration) {
  if (duration <= 0) return;
  var difference = to - element.scrollLeft;
  var perTick = difference / duration * 10;

  setTimeout(function () {
    element.scrollLeft = element.scrollLeft + perTick;
    if (element.scrollLeft === to) return;
    animateScrollTo(element, to, duration - 10);
  }, 10);
}

const scrollLeft = e => {
  let scrollContainer = findAncestor(e.target, 'contain').querySelectorAll(".row-scroll")[0];
  let position = scrollContainer.scrollLeft - window.innerWidth;
  animateScrollTo(scrollContainer, position, 600);
};

const scrollRight = e => {
  let scrollContainer = findAncestor(e.target, 'contain').querySelectorAll(".row-scroll")[0];
  let position = scrollContainer.scrollLeft + window.innerWidth;
  animateScrollTo(scrollContainer, position, 600);
};

const doRequest = (url, params) => {
  let seperator = '?';
  for (var key in params) {
    url += seperator + key + '=' + params[key];
    seperator = '&';
  }

  return fetch(url);
};

const renderSliderControls = size => {
  if (size <= 4) {
    return false;
  }

  return /*#__PURE__*/(
    React.createElement("div", { className: "controls-wrapper" }, /*#__PURE__*/
    React.createElement("div", { className: "controls controls-left",
      onClick: scrollLeft }), /*#__PURE__*/
    React.createElement("div", { className: "controls controls-right",
      onClick: scrollRight })));


};

const renderAddToListButton = (isListed, onClickHandler) => {
  if (isListed) {
    return /*#__PURE__*/(
      React.createElement("button", { className: "btn-list btn-list-remove", onClick: onClickHandler }));

  }

  return /*#__PURE__*/(
    React.createElement("button", { className: "btn-list", onClick: onClickHandler }));

};


/**************************************************/
// Reducers
/**************************************************/
const foundReducer = (state = {}, action) => {
  switch (action.type) {
    case SEARCH_VIDEOS:
      return { ..._.mapKeys(action.payload.items, function (value, key) {
          return value.id.videoId;
        }) };

    default:return state;}

};

const videosReducer = (state = {}, action) => {
  switch (action.type) {
    case FETCH_CAT_VIDEOS:
      return { ...state, ..._.mapKeys(action.payload.items, function (value, key) {
          return value.id.videoId;
        }) };

    default:return state;}


  return state;
};

const popularVideosReducer = (state = {}, action) => {
  switch (action.type) {
    case FETCH_POPULAR_CAT_VIDEOS:
      return { ...state, ..._.mapKeys(action.payload.items, function (value, key) {
          return value.id.videoId;
        }) };

    default:return state;}

};

const listedVideosReducer = (state = {}, action) => {
  switch (action.type) {
    case REMOVE_VIDEO_FROM_LIST:
      return _.omit({ ...state }, [action.payload]);

    case ADD_VIDEO_TO_LIST:
      return { ...state, ..._.mapKeys(action.payload.items, function (value, key) {
          return value.id;
        }) };

    default:return state;}


  return state;
};

const featuredVideoReducer = (state = {}, action) => {
  switch (action.type) {
    case FETCH_FEATURED_VIDEO:
      return action.payload.items[0];

    default:return state;}

};

const watchedVideosReducer = (state = {}, action) => {
  switch (action.type) {
    case ADD_TO_WATCHED:
      return { ...state, ..._.mapKeys(action.payload.items, function (value, key) {
          return value.id;
        }) };

    default:return state;}

};

let rootReducer = combineReducers({
  videos: videosReducer,
  popularVideos: popularVideosReducer,
  listedVideos: listedVideosReducer,
  featuredVideo: featuredVideoReducer,
  foundVideos: foundReducer,
  watchedVideos: watchedVideosReducer });



/**************************************************/
// Actions Creators
/**************************************************/
const actionCreators = {
  searchVideos: term => {
    const request = doRequest(API_BASE_URL + 'search', {
      key: API_KEY,
      q: 'cat ' + term,
      maxResults: 50,
      part: 'snippet' });


    return {
      type: SEARCH_VIDEOS,
      payload: request };

  },
  addToWatchedVideos: videoId => {
    const request = doRequest(API_BASE_URL + 'videos', {
      key: API_KEY,
      id: videoId,
      part: 'snippet' });


    return {
      type: ADD_TO_WATCHED,
      payload: request };

  },
  addVideoToList: video => {
    const videoId = video.id.videoId || video.id;
    const request = doRequest(API_BASE_URL + 'videos', {
      key: API_KEY,
      id: videoId,
      part: 'snippet' });


    return {
      type: ADD_VIDEO_TO_LIST,
      payload: request };

  },
  removeVideoFromList: id => {
    return {
      type: REMOVE_VIDEO_FROM_LIST,
      payload: id };

  },
  fetchFeaturedVideo: () => {
    //@TODO pass id
    const request = doRequest(API_BASE_URL + 'videos', {
      key: API_KEY,
      id: 'cs2mKXqQUOY',
      part: 'snippet' });


    return {
      type: FETCH_FEATURED_VIDEO,
      payload: request };

  },
  fetchCatVideos: () => {
    const request = doRequest(API_BASE_URL + 'search', {
      key: API_KEY,
      part: 'snippet',
      q: 'cat',
      maxResults: 10 });


    return {
      type: FETCH_CAT_VIDEOS,
      payload: request };

  },
  fetchPopularCatVideos: () => {
    const request = doRequest(API_BASE_URL + 'search', {
      key: API_KEY,
      part: 'snippet',
      q: 'cat',
      maxResults: 10 });


    return {
      type: FETCH_POPULAR_CAT_VIDEOS,
      payload: request };

  } };


/**************************************************/
// Store
/**************************************************/
const preloadedState = { videos: {}, popularVideos: {}, listedVideos: {}, featuredVideo: {}, foundVideos: {}, watchedVideos: {} };
const store = createStore(rootReducer, preloadedState, applyMiddleware(async));



/**************************************************/
// Connect
/**************************************************/
const AppContainer = connect(
function mapStateToProps({
  videos, popularVideos, listedVideos, featuredVideo, foundVideos, watchedVideos },
props) {
  return {
    videos,
    popularVideos,
    listedVideos,
    featuredVideo,
    foundVideos,
    watchedVideos };

},
function mapDispatchToProps(dispatch) {
  return bindActionCreators(actionCreators, dispatch);
})(
App);

store.dispatch(actionCreators.fetchCatVideos());
store.dispatch(actionCreators.fetchPopularCatVideos());
store.dispatch(actionCreators.fetchFeaturedVideo());


/**************************************************/
// Routing
/**************************************************/
const PATHS = {
  '/': Browse,
  '/watch': Watch,
  '/search': Search };



/**************************************************/
// Render
/**************************************************/
ReactDOM.render( /*#__PURE__*/
React.createElement(Provider, { store: store }, /*#__PURE__*/
React.createElement(AppContainer, null)),

document.getElementById("app"));